package org.fuseri.model.dto.exercise;

import jakarta.validation.Valid;
import jakarta.validation.constraints.NotBlank;
import lombok.Getter;
import lombok.Setter;
import org.fuseri.model.dto.common.DomainObjectDto;

import java.util.List;
import java.util.Objects;

@Getter
@Setter
public class QuestionDto extends DomainObjectDto {

    @NotBlank
    private String text;

    @NotBlank
    private String exerciseId;

    @Valid
    private List<AnswerDto> answers;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        QuestionDto that = (QuestionDto) o;

        if (!Objects.equals(text, that.text)) return false;
        if (!Objects.equals(exerciseId, that.exerciseId)) return false;
        return Objects.equals(answers, that.answers);
    }

    @Override
    public int hashCode() {
        int result = text != null ? text.hashCode() : 0;
        result = 31 * result + (exerciseId != null ? exerciseId.hashCode() : 0);
        result = 31 * result + (answers != null ? answers.hashCode() : 0);
        return result;
    }
}
