package org.fuseri.moduleexercise.question;

import org.fuseri.moduleexercise.common.DomainRepository;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

/**
 * A repository interface for managing Question entities
 */
public interface QuestionRepository extends DomainRepository<Question, String> {

    /**
     * Find a page of questions associated with the exercise with the specified ID
     *
     * @param exerciseId  the ID of the exercise to find questions for
     * @param pageRequest the page request specifying the page number and page size
     * @return a page of questions associated with the specified exercise
     */
    Page<Question> findByExerciseId(String exerciseId, PageRequest pageRequest);
}